#include "edge.h"

Edge *edgeFromPair(int source, int target, QDateTime start)
{
	Edge *edge = new Edge;

	edge->source = source;
	edge->target = target;
	edge->start = start;

	return edge;
}

Edge *edgeFromReply(QVariantMap reply)
{
	if(reply["twitter"].toMap()["in_reply_to_user_id"].isNull()) return NULL;

	Edge *edge = new Edge;

	edge->source = reply["twitter"].toMap()["user"].toMap()["id"].toInt();
	edge->target = reply["twitter"].toMap()["in_reply_to_user_id"].toInt();
	edge->start = QDateTime::fromString(reply["twitter"].toMap()["created_at"].toString(), "ddd, dd MMM yyyy h:mm:ss +0000");

	return edge;
}

Edge *edgeFromRetweet(QVariantMap retweet)
{
	if(retweet["twitter"].toMap()["retweet"].isNull()) return NULL;

	Edge *edge = new Edge;

	edge->source = retweet["twitter"].toMap()["retweet"].toMap()["user"].toMap()["id"].toInt();
	edge->target = retweet["twitter"].toMap()["retweeted"].toMap()["user"].toMap()["id"].toInt();
	edge->start = QDateTime::fromString(retweet["twitter"].toMap()["retweet"].toMap()["created_at"].toString(), "ddd, dd MMM yyyy h:mm:ss +0000");

	return edge;
}

