#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtGui>

#include <qjson/parser.h>
#include <qjson/serializer.h>

#include "runwindow.h"
#include "aboutqttwitgraph.h"

#include "../manager/setting.h"
#include "../network/apitwitter.h"



#include <QRegExp>

#define SETTING_FILE ".QtTwitGraph_v2_settings"


namespace Ui {
	class MainWindow;
}

class MainWindow : public QMainWindow
{
		Q_OBJECT
		
	public:
		explicit MainWindow(QWidget *parent = 0);
		~MainWindow();
		void closeEvent(QCloseEvent *event);

	private slots:
		void on_actionRun_triggered();
		void on_actionSave_settings_triggered();
		void on_actionAbout_triggered();
		void on_actionView_Help_triggered();
		void on_run_pushButton_clicked();

		void on_path_button_clicked();

		void on_datasiftAdd_pushButton_clicked();
		void on_datasiftClear_pushButton_clicked();
		void on_datasiftDelete_pushButton_clicked();
		void datasiftDeleteFirst();
		void on_datasiftDeleteAll_pushButton_clicked();

		void on_twitterAdd_pushButton_clicked();
		void on_twitterDelete_pushButton_clicked();
		void on_twitterDeleteAll_pushButton_clicked();

		void setChanged(bool value = true);

	public slots:
		void addTwitterIdpw(QString username, QString token, QString tokenSecret, bool change = true);

	private:
		void run();
		void addDatasiftIdpw(QString username, QString apikey, bool change = true);

		void getSettings();
		void saveSettings(bool notification = false);

		Ui::MainWindow *ui;

		bool _settingsChanged;
};

#endif // MAINWINDOW_H
